module     p17_ddbar_neepdubar_d15h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p17_ddbar_neepdubar/helicity1/d15h1l1d.f90
   ! generator: haggies (1.1)
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d15
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd15h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k3+k6+k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t3 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb15n13+t1*abb15n26+abb15n16*dotproduct(qshift, qshift)+a&
         &bb15n23*dotproduct(k5, qshift)+abb15n24*dotproduct(k1, qshift)+abb15n2&
         &4*dotproduct(k6, qshift)+abb15n25*(spvak5k6(1)*qshift(1)-spvak5k6(2)*q&
         &shift(2)-spvak5k6(3)*qshift(3)-spvak5k6(4)*qshift(4))+abb15n27*(spvak2&
         &k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4&
         &)*qshift(4))+abb15n28*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spv&
         &ak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+t1*t2*abb15n14+t1*t3*abb15n1&
         &5)
         return
      end if
      t4 = spvak5k1(iv1)
      t5 = spvak2k6(iv1)
      t6 = spvak3k6(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb15n21+k5(iv1)*abb15n22+k6(iv1)*abb15n21+qshift(&
         &iv1)*abb15n29+spvak2k1(iv1)*abb15n18+spvak3k1(iv1)*abb15n17+spvak5k6(i&
         &v1)*abb15n20+t4*abb15n19+t1*t5*abb15n30+t1*t6*abb15n31+t2*t4*abb15n31+&
         &t3*t4*abb15n30)
         return
      end if
      t1 = spvak5k1(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb15n16+spvak2k6(iv2)*t4*abb15n15+spv&
         &ak3k6(iv2)*t4*abb15n14+t1*t5*abb15n15+t1*t6*abb15n14)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d15:
   subroutine     reconstruct_d15(coeffs)
      use p17_ddbar_neepdubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_15:
      coeffs%coeffs_15%c0 = derivative(czip)
      coeffs%coeffs_15%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_15%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_15%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_15%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_15%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_15%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_15%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_15%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_15%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_15%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_15%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_15%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_15%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_15%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_15:
   end subroutine reconstruct_d15
!---#] subroutine reconstruct_d15:
end module p17_ddbar_neepdubar_d15h1l1d
