module     p17_ddbar_neepdubar_d17h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p17_ddbar_neepdubar/helicity1/d17h1l1d.f90
   ! generator: haggies (1.1)
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d17
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd17h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t15 = dotproduct(k3, qshift)
      t16 = dotproduct(k4, qshift)
      t17 = dotproduct(k6, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t5 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb17n18+t1*abb17n26+t15*abb17n25+t16*abb17n25+t17*abb17n2&
         &5+t2*abb17n27+t3*abb17n33+abb17n24*dotproduct(qshift, qshift)+abb17n28&
         &*dotproduct(k2, qshift)+abb17n29*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qs&
         &hift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb17n30*dotprodu&
         &ct(k5, qshift)+abb17n32*dotproduct(k1, qshift)+t1*t3*abb17n22+t15*t3*a&
         &bb17n23+t16*t3*abb17n23+t17*t3*abb17n23+t2*t3*abb17n21+t3*t4*abb17n19+&
         &t3*t5*abb17n20)
         return
      end if
      t6 = k3(iv1)
      t7 = k4(iv1)
      t8 = k6(iv1)
      t9 = spvak3k4(iv1)
      t10 = spvak3k6(iv1)
      t11 = spvak5k1(iv1)
      t12 = spvak2k4(iv1)
      t13 = spvak2k6(iv1)
      t14 = t11*abb17n23
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb17n32+k2(iv1)*abb17n28+k5(iv1)*abb17n30+qshift(&
         &iv1)*abb17n31+spvak2k1(iv1)*abb17n29+t10*abb17n27+t11*abb17n33+t14*t15&
         &+t14*t16+t14*t17+t6*abb17n25+t7*abb17n25+t8*abb17n25+t9*abb17n26+t1*t1&
         &1*abb17n22+t10*t3*abb17n21+t11*t2*abb17n21+t11*t4*abb17n19+t11*t5*abb1&
         &7n20+t12*t3*abb17n20+t13*t3*abb17n19+t3*t6*abb17n23+t3*t7*abb17n23+t3*&
         &t8*abb17n23+t3*t9*abb17n22)
         return
      end if
      t1 = spvak5k1(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb17n24+k3(iv2)*t11*abb17n23+k4(iv2)*&
         &t11*abb17n23+k6(iv2)*t11*abb17n23+spvak2k4(iv2)*t11*abb17n20+spvak2k6(&
         &iv2)*t11*abb17n19+spvak3k4(iv2)*t11*abb17n22+spvak3k6(iv2)*t11*abb17n2&
         &1+t1*t10*abb17n21+t1*t12*abb17n20+t1*t13*abb17n19+t1*t6*abb17n23+t1*t7&
         &*abb17n23+t1*t8*abb17n23+t1*t9*abb17n22)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d17:
   subroutine     reconstruct_d17(coeffs)
      use p17_ddbar_neepdubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_17:
      coeffs%coeffs_17%c0 = derivative(czip)
      coeffs%coeffs_17%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_17%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_17%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_17%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_17%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_17%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_17%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_17%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_17%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_17%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_17%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_17%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_17%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_17:
   end subroutine reconstruct_d17
!---#] subroutine reconstruct_d17:
end module p17_ddbar_neepdubar_d17h1l1d
