module     p17_ddbar_neepdubar_d6h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p17_ddbar_neepdubar/helicity1/d6h1l1.f90
   ! generator: haggies (1.1)
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p17_ddbar_neepdubar_groups, only: &
!           & sign => diagram6_sign, shift => diagram6_shift
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd6h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d6 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      d6 = (abb6n1+t1*abb6n11+t2*abb6n14+t3*abb6n15+t4*abb6n16+t5*abb6n17+t6*abb&
      &6n18+t7*abb6n2+t8*abb6n28+t9*abb6n9+t1*t8*abb6n27+t10*t2*abb6n20+t10*t3*a&
      &bb6n20+t10*t4*abb6n21+t10*t5*abb6n22+t10*t8*abb6n30+t11*t8*abb6n24+t11*t9&
      &*abb6n23+t12*t2*abb6n8+t12*t3*abb6n8+t12*t4*abb6n7+t12*t5*abb6n6+t12*t8*a&
      &bb6n29+t2*t6*abb6n3+t3*t6*abb6n3+t3*t8*abb6n26+t3*t9*abb6n12+t4*t6*abb6n4&
      &+t4*t9*abb6n13+t5*t6*abb6n5+t6*t8*abb6n25+t6*t9*abb6n19+t7*t8*abb6n4+t9*a&
      &bb6n10*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(&
      &4))+t11*t8*t9*abb6n31)
      numerator = cmplx(real(d6, ki), aimag(d6), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd6h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d6 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))
      t8 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      d6 = (abb6n1+t1*abb6n11+t2*abb6n14+t3*abb6n15+t4*abb6n16+t5*abb6n17+t6*abb&
      &6n18+t7*abb6n2+t8*abb6n28+t9*abb6n9+t1*t8*abb6n27+t10*t2*abb6n20+t10*t3*a&
      &bb6n20+t10*t4*abb6n21+t10*t5*abb6n22+t10*t8*abb6n30+t11*t8*abb6n24+t11*t9&
      &*abb6n23+t12*t2*abb6n8+t12*t3*abb6n8+t12*t4*abb6n7+t12*t5*abb6n6+t12*t8*a&
      &bb6n29+t2*t6*abb6n3+t3*t6*abb6n3+t3*t8*abb6n26+t3*t9*abb6n12+t4*t6*abb6n4&
      &+t4*t9*abb6n13+t5*t6*abb6n5+t6*t8*abb6n25+t6*t9*abb6n19+t7*t8*abb6n4+t9*a&
      &bb6n10*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(&
      &4))+t11*t8*t9*abb6n31)

      numerator = cmplx(real(d6, ki), aimag(d6), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p17_ddbar_neepdubar_d6h1l1
