module     p24_udbar_neepuubar_d51h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p24_udbar_neepuubar/helicity1/d51h1l1d.f90
   ! generator: haggies (1.1)
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d51
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p24_udbar_neepuubar_globalsl1, only: epspow
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_abbrevd51h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb51n10+abb51n11*(spvak2k4(1)*qshift(1)-spvak2k4(2)*qshif&
         &t(2)-spvak2k4(3)*qshift(3)-spvak2k4(4)*qshift(4))+abb51n12*(spvak2k6(1&
         &)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qs&
         &hift(4))+abb51n13*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k&
         &4(3)*qshift(3)-spvak5k4(4)*qshift(4))+abb51n14*dotproduct(k3, qshift)+&
         &abb51n14*dotproduct(k4, qshift)+abb51n14*dotproduct(k6, qshift)+abb51n&
         &15*(spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-&
         &spvak5k6(4)*qshift(4))+abb51n16*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qsh&
         &ift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb51n17*(spvak3k6&
         &(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb51n14+k4(iv1)*abb51n14+k6(iv1)*abb51n14+spvak2k&
         &4(iv1)*abb51n11+spvak2k6(iv1)*abb51n12+spvak3k4(iv1)*abb51n16+spvak3k6&
         &(iv1)*abb51n17+spvak5k4(iv1)*abb51n13+spvak5k6(iv1)*abb51n15)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d51:
   subroutine     reconstruct_d51(coeffs)
      use p24_udbar_neepuubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_51:
      coeffs%coeffs_51%c0 = derivative(czip)
      coeffs%coeffs_51%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_51%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_51%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_51%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_51:
   end subroutine reconstruct_d51
!---#] subroutine reconstruct_d51:
end module p24_udbar_neepuubar_d51h1l1d
