module     p25_udbar_neepssbar_d26h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p25_udbar_neepssbar/helicity0/d26h0l1.f90
   ! generator: haggies (1.1)
   use p25_udbar_neepssbar_config, only: ki
   use p25_udbar_neepssbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p25_udbar_neepssbar_groups, only: &
!           & sign => diagram26_sign, shift => diagram26_shift
      use p25_udbar_neepssbar_globalsl1, only: epspow
      use p25_udbar_neepssbar_kinematics
      use p25_udbar_neepssbar_abbrevd26h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d26

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d26 = 0.0_ki
      d26 = (abb26n1+abb26n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb26n3*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6&
      &k1(3)-Q(4)*spvak6k1(4))+abb26n4*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*s&
      &pvak2k4(3)-Q(4)*spvak2k4(4))+abb26n5*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q&
      &(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+abb26n6*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(&
      &3)-Q(4)*k1(4))+abb26n7*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+abb2&
      &6n7*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb26n8*(Q(1)*spvak3k4(&
      &1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb26n9*(Q(1)*spva&
      &k3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)))
      numerator = cmplx(real(d26, ki), aimag(d26), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p25_udbar_neepssbar_globalsl1, only: epspow
      use p25_udbar_neepssbar_kinematics
      use p25_udbar_neepssbar_abbrevd26h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d26

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d26 = 0.0_ki
      d26 = (abb26n1+abb26n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb26n3*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6&
      &k1(3)-Q(4)*spvak6k1(4))+abb26n4*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*s&
      &pvak2k4(3)-Q(4)*spvak2k4(4))+abb26n5*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q&
      &(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+abb26n6*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(&
      &3)-Q(4)*k1(4))+abb26n7*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+abb2&
      &6n7*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb26n8*(Q(1)*spvak3k4(&
      &1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb26n9*(Q(1)*spva&
      &k3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)))

      numerator = cmplx(real(d26, ki), aimag(d26), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p25_udbar_neepssbar_d26h0l1
