module     p25_udbar_neepssbar_d30h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p25_udbar_neepssbar/helicity1/d30h1l1d.f90
   ! generator: haggies (1.1)
   use p25_udbar_neepssbar_config, only: ki
   use p25_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d30
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p25_udbar_neepssbar_globalsl1, only: epspow
      use p25_udbar_neepssbar_kinematics
      use p25_udbar_neepssbar_abbrevd30h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb30n18
         return
      end if
      t1 = k1(iv1)
      t2 = k3(iv1)
      t3 = k4(iv1)
      t4 = spvak3k1(iv1)
      t5 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (spvak2k1(iv1)*abb30n26+spvak2k4(iv1)*abb30n28+spvak2k6(iv1&
         &)*abb30n27+spvak5k6(iv1)*abb30n29+t1*abb30n30+t2*abb30n31+t3*abb30n31+&
         &t4*abb30n33+t5*abb30n32)
         return
      end if
      t6 = spvak3k6(iv2)
      t7 = spvak3k6(iv1)
      t8 = spvak3k1(iv2)
      t9 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb30n24+k1(iv2)*t7*abb30n20+k3(iv2)*t&
         &7*abb30n23+k4(iv2)*t7*abb30n23+spvak1k6(iv1)*t8*abb30n22+spvak1k6(iv2)&
         &*t4*abb30n22+spvak4k6(iv1)*t9*abb30n21+spvak4k6(iv2)*t5*abb30n21+t1*t6&
         &*abb30n20+t2*t6*abb30n23+t3*t6*abb30n23+t4*t6*abb30n19+t5*t6*abb30n25+&
         &t7*t8*abb30n19+t7*t9*abb30n25)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d30:
   subroutine     reconstruct_d30(coeffs)
      use p25_udbar_neepssbar_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_30:
      coeffs%coeffs_30%c0 = derivative(czip)
      coeffs%coeffs_30%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_30%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_30%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_30%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_30%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_30%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_30%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_30%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_30%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_30%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_30%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_30%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_30%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_30%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_30:
   end subroutine reconstruct_d30
!---#] subroutine reconstruct_d30:
end module p25_udbar_neepssbar_d30h1l1d
