module     p26_udbar_neepgg_d13h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d13h0l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d13
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd13h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb13n13+abb13n24*dotproduct(k3, qshift)+abb13n24*dotprodu&
         &ct(k4, qshift)+abb13n25*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-s&
         &pvak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+abb13n26*(spvak3k4(1)*qshi&
         &ft(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4&
         &))+abb13n27*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*q&
         &shift(3)-spvak5k1(4)*qshift(4))+abb13n28*dotproduct(k1, qshift)+abb13n&
         &29*dotproduct(k6, qshift)+abb13n30*(spvak5k6(1)*qshift(1)-spvak5k6(2)*&
         &qshift(2)-spvak5k6(3)*qshift(3)-spvak5k6(4)*qshift(4))+abb13n31*dotpro&
         &duct(k5, qshift)+abb13n32*dotproduct(k2, qshift)+abb13n33*(spvak2k5(1)&
         &*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-spvak2k5(4)*qsh&
         &ift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb13n19+k2(iv1)*abb13n15+k3(iv1)*abb13n23+k4(iv1)&
         &*abb13n23+k5(iv1)*abb13n16+k6(iv1)*abb13n18+spvak2k5(iv1)*abb13n14+spv&
         &ak3k1(iv1)*abb13n22+spvak3k4(iv1)*abb13n21+spvak5k1(iv1)*abb13n20+spva&
         &k5k6(iv1)*abb13n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d13:
   subroutine     reconstruct_d13(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_13:
      coeffs%coeffs_13%c0 = derivative(czip)
      coeffs%coeffs_13%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_13%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_13%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_13%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_13:
   end subroutine reconstruct_d13
!---#] subroutine reconstruct_d13:
end module p26_udbar_neepgg_d13h0l1d
