module     p26_udbar_neepgg_d23h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d23h0l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram23_sign, shift => diagram23_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd23h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d23
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d23 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      d23 = (t1*abb23n1+t10*abb23n9+t2*abb23n16+t3*abb23n17+t4*abb23n2+t5*abb23n&
      &3+t6*abb23n4+t7*abb23n5+t8*abb23n7+t9*abb23n8+t1*t10*abb23n14+t1*t2*abb23&
      &n31+t1*t3*abb23n33+t1*t4*abb23n13+t1*t5*abb23n19+t1*t6*abb23n20+t1*t8*abb&
      &23n28+t1*t9*abb23n27+t1*abb23n18*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*&
      &spvak2k4(3)-Q(4)*spvak2k4(4))+t10*t6*abb23n11+t10*t7*abb23n12+t2*t6*abb23&
      &n29+t2*t7*abb23n30+t3*t4*abb23n6+t3*t6*abb23n35+t3*t7*abb23n34+t6*t8*abb2&
      &3n24+t6*t9*abb23n25+t7*t8*abb23n26+t7*t9*abb23n23+t1*t10*t4*abb23n10+t1*t&
      &2*t4*abb23n32+t1*t4*t8*abb23n22+t1*t4*t9*abb23n21+t1*t4*abb23n15*(Q(1)*sp&
      &vak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t1*t4*abb23&
      &n36*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))&
      &)
      numerator = cmplx(real(d23, ki), aimag(d23), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd23h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d23
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d23 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      d23 = (t1*abb23n1+t10*abb23n9+t2*abb23n16+t3*abb23n17+t4*abb23n2+t5*abb23n&
      &3+t6*abb23n4+t7*abb23n5+t8*abb23n7+t9*abb23n8+t1*t10*abb23n14+t1*t2*abb23&
      &n31+t1*t3*abb23n33+t1*t4*abb23n13+t1*t5*abb23n19+t1*t6*abb23n20+t1*t8*abb&
      &23n28+t1*t9*abb23n27+t1*abb23n18*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*&
      &spvak2k4(3)-Q(4)*spvak2k4(4))+t10*t6*abb23n11+t10*t7*abb23n12+t2*t6*abb23&
      &n29+t2*t7*abb23n30+t3*t4*abb23n6+t3*t6*abb23n35+t3*t7*abb23n34+t6*t8*abb2&
      &3n24+t6*t9*abb23n25+t7*t8*abb23n26+t7*t9*abb23n23+t1*t10*t4*abb23n10+t1*t&
      &2*t4*abb23n32+t1*t4*t8*abb23n22+t1*t4*t9*abb23n21+t1*t4*abb23n15*(Q(1)*sp&
      &vak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t1*t4*abb23&
      &n36*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))&
      &)

      numerator = cmplx(real(d23, ki), aimag(d23), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d23h0l1
