module     p26_udbar_neepgg_d93h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d93h0l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram93_sign, shift => diagram93_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd93h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d93
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d93 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t8 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t11 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t12 = t5*abb93n39
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d93 = (abb93n1+t1*abb93n2+t10*abb93n9+t12*t4+t12*t9+t2*abb93n22+t3*abb93n3&
      &+t4*abb93n30+t5*abb93n31+t5*t5*abb93n40+t6*abb93n32+t6*t6*abb93n41+t7*abb&
      &93n4+t8*abb93n49+t9*abb93n7+t1*t2*abb93n33+t1*t5*abb93n6+t1*t6*abb93n5+t1&
      &*t7*abb93n10+t1*t8*abb93n21+t1*t9*abb93n5+t10*t2*abb93n70+t10*t3*abb93n13&
      &+t10*t4*abb93n61+t10*t5*abb93n60+t10*t6*abb93n59+t10*t8*abb93n69+t11*t5*a&
      &bb93n15+t11*t6*abb93n14+t11*t9*abb93n16+t2*t3*abb93n29+t2*t4*abb93n34+t2*&
      &t5*abb93n45+t2*t6*abb93n36+t2*t7*abb93n78+t2*t8*abb93n50+t2*t9*abb93n44+t&
      &3*t4*abb93n20+t3*t5*abb93n19+t3*t6*abb93n18+t3*t7*abb93n17+t3*t8*abb93n28&
      &+t3*t9*abb93n8+t4*t6*abb93n38+t4*t7*abb93n12+t4*t8*abb93n35+t4*t9*abb93n4&
      &3+t5*t6*abb93n42+t5*t7*abb93n11+t5*t8*abb93n55+t6*t8*abb93n54+t6*t9*abb93&
      &n37+t7*t8*abb93n77+t8*t9*abb93n56+t1*t10*t2*abb93n65+t1*t2*t8*abb93n25+t1&
      &*t7*t8*abb93n68+t10*t2*t4*abb93n63+t10*t2*t5*abb93n64+t10*t2*t8*abb93n68+&
      &t10*t3*t4*abb93n74+t10*t3*t5*abb93n75+t10*t3*t6*abb93n76+t11*t2*t5*abb93n&
      &80+t11*t2*t6*abb93n79+t11*t2*t8*abb93n82+t11*t2*t9*abb93n81+t11*t5*t8*abb&
      &93n72+t11*t6*t8*abb93n71+t11*t8*t9*abb93n73+t13*t2*t8*abb93n58+t2*t3*t5*a&
      &bb93n47+t2*t3*t6*abb93n46+t2*t3*t8*abb93n57+t2*t3*t9*abb93n46+t2*t4*t8*ab&
      &b93n24+t2*t5*t8*abb93n26+t2*t6*t8*abb93n23+t2*t7*t8*abb93n62+t2*t8*abb93n&
      &27*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+&
      &t2*t8*abb93n48*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*s&
      &pvak2k4(4))+t3*t4*t8*abb93n51+t3*t5*t8*abb93n53+t3*t6*t8*abb93n52+t3*t8*t&
      &9*abb93n52+t4*t7*t8*abb93n66+t5*t7*t8*abb93n67+t13*t2*t3*t8*abb93n83)
      numerator = cmplx(real(d93, ki), aimag(d93), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd93h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d93
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d93 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t8 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t11 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t12 = t5*abb93n39
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d93 = (abb93n1+t1*abb93n2+t10*abb93n9+t12*t4+t12*t9+t2*abb93n22+t3*abb93n3&
      &+t4*abb93n30+t5*abb93n31+t5*t5*abb93n40+t6*abb93n32+t6*t6*abb93n41+t7*abb&
      &93n4+t8*abb93n49+t9*abb93n7+t1*t2*abb93n33+t1*t5*abb93n6+t1*t6*abb93n5+t1&
      &*t7*abb93n10+t1*t8*abb93n21+t1*t9*abb93n5+t10*t2*abb93n70+t10*t3*abb93n13&
      &+t10*t4*abb93n61+t10*t5*abb93n60+t10*t6*abb93n59+t10*t8*abb93n69+t11*t5*a&
      &bb93n15+t11*t6*abb93n14+t11*t9*abb93n16+t2*t3*abb93n29+t2*t4*abb93n34+t2*&
      &t5*abb93n45+t2*t6*abb93n36+t2*t7*abb93n78+t2*t8*abb93n50+t2*t9*abb93n44+t&
      &3*t4*abb93n20+t3*t5*abb93n19+t3*t6*abb93n18+t3*t7*abb93n17+t3*t8*abb93n28&
      &+t3*t9*abb93n8+t4*t6*abb93n38+t4*t7*abb93n12+t4*t8*abb93n35+t4*t9*abb93n4&
      &3+t5*t6*abb93n42+t5*t7*abb93n11+t5*t8*abb93n55+t6*t8*abb93n54+t6*t9*abb93&
      &n37+t7*t8*abb93n77+t8*t9*abb93n56+t1*t10*t2*abb93n65+t1*t2*t8*abb93n25+t1&
      &*t7*t8*abb93n68+t10*t2*t4*abb93n63+t10*t2*t5*abb93n64+t10*t2*t8*abb93n68+&
      &t10*t3*t4*abb93n74+t10*t3*t5*abb93n75+t10*t3*t6*abb93n76+t11*t2*t5*abb93n&
      &80+t11*t2*t6*abb93n79+t11*t2*t8*abb93n82+t11*t2*t9*abb93n81+t11*t5*t8*abb&
      &93n72+t11*t6*t8*abb93n71+t11*t8*t9*abb93n73+t13*t2*t8*abb93n58+t2*t3*t5*a&
      &bb93n47+t2*t3*t6*abb93n46+t2*t3*t8*abb93n57+t2*t3*t9*abb93n46+t2*t4*t8*ab&
      &b93n24+t2*t5*t8*abb93n26+t2*t6*t8*abb93n23+t2*t7*t8*abb93n62+t2*t8*abb93n&
      &27*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+&
      &t2*t8*abb93n48*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*s&
      &pvak2k4(4))+t3*t4*t8*abb93n51+t3*t5*t8*abb93n53+t3*t6*t8*abb93n52+t3*t8*t&
      &9*abb93n52+t4*t7*t8*abb93n66+t5*t7*t8*abb93n67+t13*t2*t3*t8*abb93n83)

      numerator = cmplx(real(d93, ki), aimag(d93), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d93h0l1
