module     p26_udbar_neepgg_d79h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d79h1l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d79
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd79h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb79n11+abb79n20*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb79n21*(spvak5k1(1&
         &)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qs&
         &hift(4))+abb79n22*(spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k&
         &4(3)*qshift(3)-spvak2k4(4)*qshift(4))+abb79n23*(spvak5k4(1)*qshift(1)-&
         &spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-spvak5k4(4)*qshift(4))+abb&
         &79n24*dotproduct(k1, qshift)+abb79n25*dotproduct(k3, qshift)+abb79n25*&
         &dotproduct(k4, qshift)+abb79n26*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qsh&
         &ift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb79n27*(spvak3k1&
         &(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb79n15+k3(iv1)*abb79n14+k4(iv1)*abb79n14+spvak2k&
         &1(iv1)*abb79n19+spvak2k4(iv1)*abb79n17+spvak3k1(iv1)*abb79n12+spvak3k4&
         &(iv1)*abb79n13+spvak5k1(iv1)*abb79n18+spvak5k4(iv1)*abb79n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d79:
   subroutine     reconstruct_d79(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_79:
      coeffs%coeffs_79%c0 = derivative(czip)
      coeffs%coeffs_79%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_79%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_79%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_79%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_79:
   end subroutine reconstruct_d79
!---#] subroutine reconstruct_d79:
end module p26_udbar_neepgg_d79h1l1d
