module     p26_udbar_neepgg_d47h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity3/d47h3l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d47
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd47h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      real(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t19 = dotproduct(k1, qshift)
      t20 = dotproduct(k3, qshift)
      t21 = dotproduct(k4, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t4 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t5 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t6 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb47n21+t1*abb47n35+t19*abb47n33+t2*abb47n36+t20*abb47n34&
         &+t21*abb47n34+t3*abb47n39+abb47n30*dotproduct(qshift, qshift)+abb47n31&
         &*dotproduct(k5, qshift)+abb47n32*dotproduct(k2, qshift)+abb47n37*dotpr&
         &oduct(k6, qshift)+t1*t3*abb47n23+t19*t3*abb47n24+t2*t3*abb47n22+t20*t3&
         &*abb47n25+t21*t3*abb47n25+t3*t4*abb47n26+t3*t5*abb47n27+t3*t6*abb47n28&
         &+t3*t7*abb47n29)
         return
      end if
      t8 = k1(iv1)
      t9 = k3(iv1)
      t10 = k4(iv1)
      t11 = spvak3k1(iv1)
      t12 = spvak3k4(iv1)
      t13 = spvak6k5(iv1)
      t14 = spvak2k1(iv1)
      t15 = spvak2k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k4(iv1)
      t18 = t13*abb47n25
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb47n32+k5(iv1)*abb47n31+k6(iv1)*abb47n37+qshift(&
         &iv1)*abb47n38+t10*abb47n34+t11*abb47n36+t12*abb47n35+t13*abb47n39+t18*&
         &t20+t18*t21+t8*abb47n33+t9*abb47n34+t1*t13*abb47n23+t10*t3*abb47n25+t1&
         &1*t3*abb47n22+t12*t3*abb47n23+t13*t19*abb47n24+t13*t2*abb47n22+t13*t4*&
         &abb47n26+t13*t5*abb47n27+t13*t6*abb47n28+t13*t7*abb47n29+t14*t3*abb47n&
         &29+t15*t3*abb47n27+t16*t3*abb47n28+t17*t3*abb47n26+t3*t8*abb47n24+t3*t&
         &9*abb47n25)
         return
      end if
      t1 = spvak6k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb47n30+k1(iv2)*t13*abb47n24+k3(iv2)*&
         &t13*abb47n25+k4(iv2)*t13*abb47n25+spvak2k1(iv2)*t13*abb47n29+spvak2k4(&
         &iv2)*t13*abb47n27+spvak3k1(iv2)*t13*abb47n22+spvak3k4(iv2)*t13*abb47n2&
         &3+spvak5k1(iv2)*t13*abb47n28+spvak5k4(iv2)*t13*abb47n26+t1*t10*abb47n2&
         &5+t1*t11*abb47n22+t1*t12*abb47n23+t1*t14*abb47n29+t1*t15*abb47n27+t1*t&
         &16*abb47n28+t1*t17*abb47n26+t1*t8*abb47n24+t1*t9*abb47n25)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d47:
   subroutine     reconstruct_d47(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_47:
      coeffs%coeffs_47%c0 = derivative(czip)
      coeffs%coeffs_47%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_47%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_47%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_47%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_47%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_47%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_47%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_47%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_47%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_47%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_47%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_47%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_47%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_47%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_47:
   end subroutine reconstruct_d47
!---#] subroutine reconstruct_d47:
end module p26_udbar_neepgg_d47h3l1d
