module     p26_udbar_neepgg_d83h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity3/d83h3l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram83_sign, shift => diagram83_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd83h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d83
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d83 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t5 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t6 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t7 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t8 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t9 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t15 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d83 = (abb83n1+t1*abb83n10+t2*abb83n11+t3*abb83n12+t4*abb83n13+t5*abb83n2+&
      &t6*abb83n23+t7*abb83n36+t7*t7*abb83n38+t8*abb83n5+t1*t12*abb83n55+t1*t13*&
      &abb83n57+t1*t14*abb83n72+t1*t2*abb83n35+t1*t4*abb83n61+t1*t5*abb83n7+t1*t&
      &6*abb83n40+t1*t7*abb83n6+t1*t8*abb83n9+t1*t9*abb83n37+t10*t2*abb83n19+t10&
      &*t4*abb83n3+t10*t6*abb83n4+t10*t7*abb83n20+t10*t9*abb83n18+t11*t8*abb83n2&
      &5+t14*t2*abb83n69+t14*t3*abb83n71+t14*t7*abb83n70+t2*t4*abb83n59+t2*t5*ab&
      &b83n29+t2*t6*abb83n51+t2*t7*abb83n30+t2*t8*abb83n27+t2*t9*abb83n45+t3*t4*&
      &abb83n56+t3*t6*abb83n49+t3*t8*abb83n8+t3*t9*abb83n43+t4*t5*abb83n15+t4*t6&
      &*abb83n14+t4*t7*abb83n58+t4*t8*abb83n16+t5*t7*abb83n39+t5*t9*abb83n26+t6*&
      &t7*abb83n50+t6*t8*abb83n22+t6*t9*abb83n24+t7*t8*abb83n46+t7*t9*abb83n44+t&
      &1*t10*t12*abb83n76+t1*t10*t6*abb83n41+t1*t10*t9*abb83n21+t1*t11*t8*abb83n&
      &32+t1*t12*t8*abb83n60+t1*t13*t5*abb83n65+t1*t13*t6*abb83n62+t1*t13*t7*abb&
      &83n63+t1*t13*t8*abb83n67+t1*t14*t5*abb83n77+t1*t14*t6*abb83n79+t1*t14*t7*&
      &abb83n78+t1*t14*t8*abb83n80+t1*t15*t8*abb83n42+t1*t2*t8*abb83n28+t1*t4*t8&
      &*abb83n64+t1*t5*t9*abb83n31+t1*t6*t8*abb83n28+t1*t6*t9*abb83n33+t1*t7*t9*&
      &abb83n32+t10*t12*t8*abb83n34+t10*t2*t8*abb83n48+t10*t4*t8*abb83n17+t10*t7&
      &*t8*abb83n47+t14*t2*t8*abb83n73+t14*t3*t8*abb83n75+t14*t7*t8*abb83n74+t15&
      &*t2*t8*abb83n54+t15*t3*t8*abb83n52+t15*t7*t8*abb83n53+t2*t4*t8*abb83n68+t&
      &3*t4*t8*abb83n66+t4*t7*t8*abb83n67+t1*t10*t12*t8*abb83n81)
      numerator = cmplx(real(d83, ki), aimag(d83), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd83h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d83
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d83 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t5 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t6 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t7 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t8 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t9 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t13 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t15 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d83 = (abb83n1+t1*abb83n10+t2*abb83n11+t3*abb83n12+t4*abb83n13+t5*abb83n2+&
      &t6*abb83n23+t7*abb83n36+t7*t7*abb83n38+t8*abb83n5+t1*t12*abb83n55+t1*t13*&
      &abb83n57+t1*t14*abb83n72+t1*t2*abb83n35+t1*t4*abb83n61+t1*t5*abb83n7+t1*t&
      &6*abb83n40+t1*t7*abb83n6+t1*t8*abb83n9+t1*t9*abb83n37+t10*t2*abb83n19+t10&
      &*t4*abb83n3+t10*t6*abb83n4+t10*t7*abb83n20+t10*t9*abb83n18+t11*t8*abb83n2&
      &5+t14*t2*abb83n69+t14*t3*abb83n71+t14*t7*abb83n70+t2*t4*abb83n59+t2*t5*ab&
      &b83n29+t2*t6*abb83n51+t2*t7*abb83n30+t2*t8*abb83n27+t2*t9*abb83n45+t3*t4*&
      &abb83n56+t3*t6*abb83n49+t3*t8*abb83n8+t3*t9*abb83n43+t4*t5*abb83n15+t4*t6&
      &*abb83n14+t4*t7*abb83n58+t4*t8*abb83n16+t5*t7*abb83n39+t5*t9*abb83n26+t6*&
      &t7*abb83n50+t6*t8*abb83n22+t6*t9*abb83n24+t7*t8*abb83n46+t7*t9*abb83n44+t&
      &1*t10*t12*abb83n76+t1*t10*t6*abb83n41+t1*t10*t9*abb83n21+t1*t11*t8*abb83n&
      &32+t1*t12*t8*abb83n60+t1*t13*t5*abb83n65+t1*t13*t6*abb83n62+t1*t13*t7*abb&
      &83n63+t1*t13*t8*abb83n67+t1*t14*t5*abb83n77+t1*t14*t6*abb83n79+t1*t14*t7*&
      &abb83n78+t1*t14*t8*abb83n80+t1*t15*t8*abb83n42+t1*t2*t8*abb83n28+t1*t4*t8&
      &*abb83n64+t1*t5*t9*abb83n31+t1*t6*t8*abb83n28+t1*t6*t9*abb83n33+t1*t7*t9*&
      &abb83n32+t10*t12*t8*abb83n34+t10*t2*t8*abb83n48+t10*t4*t8*abb83n17+t10*t7&
      &*t8*abb83n47+t14*t2*t8*abb83n73+t14*t3*t8*abb83n75+t14*t7*t8*abb83n74+t15&
      &*t2*t8*abb83n54+t15*t3*t8*abb83n52+t15*t7*t8*abb83n53+t2*t4*t8*abb83n68+t&
      &3*t4*t8*abb83n66+t4*t7*t8*abb83n67+t1*t10*t12*t8*abb83n81)

      numerator = cmplx(real(d83, ki), aimag(d83), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d83h3l1
