module     p2_ddbar_emnebarcsbar_d27h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p2_ddbar_emnebarcsbar/helicity0/d27h0l1.f90
   ! generator: haggies (1.1)
   use p2_ddbar_emnebarcsbar_config, only: ki
   use p2_ddbar_emnebarcsbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p2_ddbar_emnebarcsbar_groups, only: &
!           & sign => diagram27_sign, shift => diagram27_shift
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd27h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d27

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k6
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d27 = 0.0_ki
      d27 = (abb27n1+abb27n2*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)&
      &-Q(4)*spvak3k2(4))+abb27n3*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5&
      &k2(3)-Q(4)*spvak5k2(4))+abb27n4*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1&
      &(4))+abb27n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb27n5*(Q(1)*&
      &k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb27n6*(Q(1)*spvak3k6(1)-Q(2)*sp&
      &vak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+abb27n7*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb27n8*(Q(1)*spvak1k2(&
      &1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+abb27n9*(Q(1)*spva&
      &k1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)))
      numerator = cmplx(real(d27, ki), aimag(d27), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd27h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d27

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k6
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d27 = 0.0_ki
      d27 = (abb27n1+abb27n2*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)&
      &-Q(4)*spvak3k2(4))+abb27n3*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5&
      &k2(3)-Q(4)*spvak5k2(4))+abb27n4*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1&
      &(4))+abb27n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb27n5*(Q(1)*&
      &k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb27n6*(Q(1)*spvak3k6(1)-Q(2)*sp&
      &vak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+abb27n7*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb27n8*(Q(1)*spvak1k2(&
      &1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+abb27n9*(Q(1)*spva&
      &k1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)))

      numerator = cmplx(real(d27, ki), aimag(d27), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p2_ddbar_emnebarcsbar_d27h0l1
