module     p2_ddbar_emnebarcsbar_d6h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p2_ddbar_emnebarcsbar/helicity0/d6h0l1.f90
   ! generator: haggies (1.1)
   use p2_ddbar_emnebarcsbar_config, only: ki
   use p2_ddbar_emnebarcsbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p2_ddbar_emnebarcsbar_groups, only: &
!           & sign => diagram6_sign, shift => diagram6_shift
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd6h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d6 = 0.0_ki
      t1 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      d6 = (abb6n3+t1*abb6n4+abb6n2*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4)&
      &)+abb6n2*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb6n2*(Q(1)*k6(1)&
      &-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb6n5*(Q(1)*spvak1k6(1)-Q(2)*spvak1k6&
      &(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+abb6n6*(Q(1)*spvak3k2(1)-Q(2)*spva&
      &k3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))+abb6n7*(Q(1)*spvak5k2(1)-Q(2)*&
      &spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+abb6n8*(Q(1)*Q(1)-Q(2)*Q(2&
      &)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb6n10*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)&
      &*spvak5k6(3)-Q(4)*spvak5k6(4))+t1*abb6n9*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(&
      &2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))
      numerator = cmplx(real(d6, ki), aimag(d6), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd6h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d6 = 0.0_ki
      t1 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      d6 = (abb6n3+t1*abb6n4+abb6n2*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4)&
      &)+abb6n2*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb6n2*(Q(1)*k6(1)&
      &-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb6n5*(Q(1)*spvak1k6(1)-Q(2)*spvak1k6&
      &(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+abb6n6*(Q(1)*spvak3k2(1)-Q(2)*spva&
      &k3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))+abb6n7*(Q(1)*spvak5k2(1)-Q(2)*&
      &spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+abb6n8*(Q(1)*Q(1)-Q(2)*Q(2&
      &)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb6n10*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)&
      &*spvak5k6(3)-Q(4)*spvak5k6(4))+t1*abb6n9*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(&
      &2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))

      numerator = cmplx(real(d6, ki), aimag(d6), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p2_ddbar_emnebarcsbar_d6h0l1
