module     p3_ud_emnebaruu_d66h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity1/d66h1l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d66
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd66h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t2 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t3 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t4 = (spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-sp&
      &vak3k5(4)*qshift(4))
      t5 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t6 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb66n12+t2*abb66n23+t3*abb66n24+t4*abb66n25+t5*abb66n2&
         &6+t6*abb66n27+t1*t5*abb66n13+t2*t6*abb66n15+t3*t6*abb66n14+t4*t5*abb66&
         &n16)
         return
      end if
      t7 = spvak1k2(iv1)
      t8 = spvak1k5(iv1)
      t9 = spvak3k2(iv1)
      t10 = spvak3k5(iv1)
      t11 = spvak6k2(iv1)
      t12 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb66n19+t11*abb66n20+t12*abb66n22+t7*abb66n18+t8*abb6&
         &6n17+t9*abb66n21+t1*t7*abb66n31+t10*t5*abb66n28+t11*t6*abb66n30+t12*t5&
         &*abb66n31+t2*t8*abb66n29+t3*t8*abb66n30+t4*t7*abb66n28+t6*t9*abb66n29)
         return
      end if
      t1 = spvak1k2(iv2)
      t2 = spvak1k5(iv2)
      if(deg.eq.2) then
         numerator = (spvak3k2(iv2)*t8*abb66n15+spvak3k5(iv2)*t7*abb66n16+spvak6&
         &k2(iv2)*t8*abb66n14+spvak6k5(iv2)*t7*abb66n13+t1*t10*abb66n16+t1*t12*a&
         &bb66n13+t11*t2*abb66n14+t2*t9*abb66n15)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d66:
   subroutine     reconstruct_d66(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_66:
      coeffs%coeffs_66%c0 = derivative(czip)
      coeffs%coeffs_66%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_66%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_66%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_66%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_66%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_66%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_66%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_66%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_66%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_66%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_66%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_66%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_66%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_66%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_66:
   end subroutine reconstruct_d66
!---#] subroutine reconstruct_d66:
end module p3_ud_emnebaruu_d66h1l1d
