module     p6_dubar_emnebarssbar_d34h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p6_dubar_emnebarssbar/helicity1/d34h1l1d.f90
   ! generator: haggies (1.1)
   use p6_dubar_emnebarssbar_config, only: ki
   use p6_dubar_emnebarssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d34
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd34h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t5 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t15 = dotproduct(k1, qshift)
      t16 = dotproduct(k3, qshift)
      t17 = dotproduct(k4, qshift)
      if(deg.eq.0) then
         numerator = (abb34n15+t1*abb34n23+abb34n18*dotproduct(qshift, qshift)+a&
         &bb34n24*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshif&
         &t(3)-spvak2k6(4)*qshift(4))+abb34n25*dotproduct(k5, qshift)+abb34n27*(&
         &spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-spva&
         &k3k6(4)*qshift(4))+t1*t15*abb34n21+t1*t16*abb34n22+t1*t17*abb34n22+t1*&
         &t2*abb34n16+t1*t3*abb34n17+t1*t4*abb34n19+t1*t5*abb34n20)
         return
      end if
      t6 = spvak5k6(iv1)
      t7 = k1(iv1)
      t8 = k3(iv1)
      t9 = k4(iv1)
      t10 = spvak2k1(iv1)
      t11 = spvak2k4(iv1)
      t12 = spvak3k1(iv1)
      t13 = spvak3k4(iv1)
      t14 = t6*abb34n22
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb34n25+qshift(iv1)*abb34n26+spvak2k6(iv1)*abb34n&
         &24+spvak3k6(iv1)*abb34n27+t14*t16+t14*t17+t6*abb34n23+t1*t10*abb34n17+&
         &t1*t11*abb34n19+t1*t12*abb34n16+t1*t13*abb34n20+t1*t7*abb34n21+t1*t8*a&
         &bb34n22+t1*t9*abb34n22+t15*t6*abb34n21+t2*t6*abb34n16+t3*t6*abb34n17+t&
         &4*t6*abb34n19+t5*t6*abb34n20)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb34n18+k1(iv2)*t6*abb34n21+k3(iv2)*t&
         &6*abb34n22+k4(iv2)*t6*abb34n22+spvak2k1(iv2)*t6*abb34n17+spvak2k4(iv2)&
         &*t6*abb34n19+spvak3k1(iv2)*t6*abb34n16+spvak3k4(iv2)*t6*abb34n20+t1*t1&
         &0*abb34n17+t1*t11*abb34n19+t1*t12*abb34n16+t1*t13*abb34n20+t1*t7*abb34&
         &n21+t1*t8*abb34n22+t1*t9*abb34n22)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d34:
   subroutine     reconstruct_d34(coeffs)
      use p6_dubar_emnebarssbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_34:
      coeffs%coeffs_34%c0 = derivative(czip)
      coeffs%coeffs_34%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_34%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_34%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_34%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_34%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_34%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_34%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_34%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_34%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_34%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_34%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_34%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_34%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_34%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_34:
   end subroutine reconstruct_d34
!---#] subroutine reconstruct_d34:
end module p6_dubar_emnebarssbar_d34h1l1d
