module     p6_dubar_emnebarssbar_d4h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p6_dubar_emnebarssbar/helicity1/d4h1l1.f90
   ! generator: haggies (1.1)
   use p6_dubar_emnebarssbar_config, only: ki
   use p6_dubar_emnebarssbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p6_dubar_emnebarssbar_groups, only: &
!           & sign => diagram4_sign, shift => diagram4_shift
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd4h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d4
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d4 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d4 = (abb4n2+t1*abb4n14+t2*abb4n4+t3*abb4n4+t4*abb4n5+t5*abb4n6+t6*abb4n7+&
      &abb4n12*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb4n13*(Q(1)*k5(1)-Q(2&
      &)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb4n13*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-&
      &Q(4)*k6(4))+abb4n15*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q&
      &(4)*spvak2k6(4))+abb4n3*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+t1*&
      &t2*abb4n9+t1*t3*abb4n9+t1*t4*abb4n10+t1*t5*abb4n11+t1*t6*abb4n17+t1*abb4n&
      &16*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+&
      &t1*abb4n8*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2&
      &k1(4)))
      numerator = cmplx(real(d4, ki), aimag(d4), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd4h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d4
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d4 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      d4 = (abb4n2+t1*abb4n14+t2*abb4n4+t3*abb4n4+t4*abb4n5+t5*abb4n6+t6*abb4n7+&
      &abb4n12*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb4n13*(Q(1)*k5(1)-Q(2&
      &)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb4n13*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-&
      &Q(4)*k6(4))+abb4n15*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q&
      &(4)*spvak2k6(4))+abb4n3*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+t1*&
      &t2*abb4n9+t1*t3*abb4n9+t1*t4*abb4n10+t1*t5*abb4n11+t1*t6*abb4n17+t1*abb4n&
      &16*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+&
      &t1*abb4n8*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2&
      &k1(4)))

      numerator = cmplx(real(d4, ki), aimag(d4), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p6_dubar_emnebarssbar_d4h1l1
