module     p7_dubar_emnebargg_d85h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity0/d85h0l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram85_sign, shift => diagram85_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd85h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d85
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k5-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d85 = 0.0_ki
      t1 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t10 = t2*abb85n22
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d85 = (t1*abb85n1+t10*t11+t10*t7+t2*abb85n2+t2*t2*abb85n21+t3*abb85n3+t4*a&
      &bb85n4+t5*abb85n9+t1*t11*abb85n42+t1*t2*abb85n12+t1*t6*abb85n10+t1*t7*abb&
      &85n13+t1*t8*abb85n43+t1*t9*abb85n36+t11*t12*abb85n5+t11*t5*abb85n48+t12*t&
      &8*abb85n6+t13*t6*abb85n7+t2*t3*abb85n15+t2*t4*abb85n25+t2*t5*abb85n38+t2*&
      &t6*abb85n8+t2*t8*abb85n23+t3*t7*abb85n16+t3*t8*abb85n14+t3*t9*abb85n18+t4&
      &*t7*abb85n26+t4*t8*abb85n24+t4*t9*abb85n30+t5*t6*abb85n11+t5*t7*abb85n37+&
      &t5*t8*abb85n49+t5*t9*abb85n17+t1*t2*t6*abb85n47+t1*t6*t7*abb85n46+t1*t8*t&
      &9*abb85n40+t11*t12*t9*abb85n32+t11*t14*t9*abb85n44+t11*t5*t9*abb85n41+t12&
      &*t2*t9*abb85n31+t12*t7*t9*abb85n32+t12*t8*t9*abb85n33+t13*t2*t6*abb85n28+&
      &t13*t6*t7*abb85n29+t13*t6*t9*abb85n34+t14*t2*t9*abb85n45+t14*t7*t9*abb85n&
      &44+t14*t8*t9*abb85n50+t2*t5*t6*abb85n51+t2*t5*t9*abb85n40+t2*t6*t8*abb85n&
      &27+t3*t8*t9*abb85n35+t4*t8*t9*abb85n19+t5*t6*t7*abb85n52+t5*t7*t9*abb85n4&
      &1+t5*t8*t9*abb85n39+t6*t8*abb85n28*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3&
      &)*spvak2k5(3)-Q(4)*spvak2k5(4))+t8*t9*abb85n20*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3&
      &)*k1(3)-Q(4)*k1(4))+t3*t6*t8*t9*abb85n53)
      numerator = cmplx(real(d85, ki), aimag(d85), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd85h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d85
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k5-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d85 = 0.0_ki
      t1 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t10 = t2*abb85n22
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d85 = (t1*abb85n1+t10*t11+t10*t7+t2*abb85n2+t2*t2*abb85n21+t3*abb85n3+t4*a&
      &bb85n4+t5*abb85n9+t1*t11*abb85n42+t1*t2*abb85n12+t1*t6*abb85n10+t1*t7*abb&
      &85n13+t1*t8*abb85n43+t1*t9*abb85n36+t11*t12*abb85n5+t11*t5*abb85n48+t12*t&
      &8*abb85n6+t13*t6*abb85n7+t2*t3*abb85n15+t2*t4*abb85n25+t2*t5*abb85n38+t2*&
      &t6*abb85n8+t2*t8*abb85n23+t3*t7*abb85n16+t3*t8*abb85n14+t3*t9*abb85n18+t4&
      &*t7*abb85n26+t4*t8*abb85n24+t4*t9*abb85n30+t5*t6*abb85n11+t5*t7*abb85n37+&
      &t5*t8*abb85n49+t5*t9*abb85n17+t1*t2*t6*abb85n47+t1*t6*t7*abb85n46+t1*t8*t&
      &9*abb85n40+t11*t12*t9*abb85n32+t11*t14*t9*abb85n44+t11*t5*t9*abb85n41+t12&
      &*t2*t9*abb85n31+t12*t7*t9*abb85n32+t12*t8*t9*abb85n33+t13*t2*t6*abb85n28+&
      &t13*t6*t7*abb85n29+t13*t6*t9*abb85n34+t14*t2*t9*abb85n45+t14*t7*t9*abb85n&
      &44+t14*t8*t9*abb85n50+t2*t5*t6*abb85n51+t2*t5*t9*abb85n40+t2*t6*t8*abb85n&
      &27+t3*t8*t9*abb85n35+t4*t8*t9*abb85n19+t5*t6*t7*abb85n52+t5*t7*t9*abb85n4&
      &1+t5*t8*t9*abb85n39+t6*t8*abb85n28*(Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3&
      &)*spvak2k5(3)-Q(4)*spvak2k5(4))+t8*t9*abb85n20*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3&
      &)*k1(3)-Q(4)*k1(4))+t3*t6*t8*t9*abb85n53)

      numerator = cmplx(real(d85, ki), aimag(d85), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d85h0l1
