module     p7_dubar_emnebargg_d93h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity1/d93h1l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram93_sign, shift => diagram93_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd93h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d93
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d93 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = t2*t2
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t3*abb93n22
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t12 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d93 = (abb93n1+t1*abb93n2+t10*t6+t10*t8+t2*abb93n20+t3*abb93n6+t3*t3*abb93&
      &n23+t4*abb93n7+t4*t4*abb93n24+t5*abb93n25+t6*abb93n3+t7*abb93n4+t8*abb93n&
      &5+t1*t2*abb93n17+t1*t3*abb93n15+t1*t4*abb93n16+t1*t5*abb93n32+t1*t8*abb93&
      &n14+t11*t5*abb93n33+t12*t2*abb93n39+t12*t5*abb93n37+t13*t5*abb93n47+t2*t3&
      &*abb93n30+t2*t4*abb93n29+t2*t6*abb93n31+t2*t7*abb93n46+t2*t8*abb93n18+t2*&
      &t9*abb93n8+t3*t4*abb93n24+t3*t5*abb93n12+t3*t7*abb93n40+t4*t5*abb93n9+t4*&
      &t6*abb93n21+t4*t7*abb93n39+t4*t8*abb93n21+t5*t7*abb93n34+t5*t8*abb93n10+t&
      &5*t9*abb93n11+t5*abb93n13*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k&
      &6(3)-Q(4)*spvak2k6(4))+t5*abb93n19*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3&
      &)*spvak2k4(3)-Q(4)*spvak2k4(4))+t6*t8*abb93n24+t7*t8*abb93n41+t1*t11*t5*a&
      &bb93n48+t1*t2*t3*abb93n28+t1*t2*t4*abb93n26+t1*t2*t6*abb93n26+t1*t2*t7*ab&
      &b93n45+t1*t2*t8*abb93n27+t13*t2*t3*abb93n43+t13*t2*t4*abb93n42+t13*t2*t6*&
      &abb93n44+t2*t3*t7*abb93n36+t2*t7*t8*abb93n35+t2*t7*t9*abb93n38)
      numerator = cmplx(real(d93, ki), aimag(d93), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd93h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d93
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d93 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = t2*t2
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = t3*abb93n22
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t12 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d93 = (abb93n1+t1*abb93n2+t10*t6+t10*t8+t2*abb93n20+t3*abb93n6+t3*t3*abb93&
      &n23+t4*abb93n7+t4*t4*abb93n24+t5*abb93n25+t6*abb93n3+t7*abb93n4+t8*abb93n&
      &5+t1*t2*abb93n17+t1*t3*abb93n15+t1*t4*abb93n16+t1*t5*abb93n32+t1*t8*abb93&
      &n14+t11*t5*abb93n33+t12*t2*abb93n39+t12*t5*abb93n37+t13*t5*abb93n47+t2*t3&
      &*abb93n30+t2*t4*abb93n29+t2*t6*abb93n31+t2*t7*abb93n46+t2*t8*abb93n18+t2*&
      &t9*abb93n8+t3*t4*abb93n24+t3*t5*abb93n12+t3*t7*abb93n40+t4*t5*abb93n9+t4*&
      &t6*abb93n21+t4*t7*abb93n39+t4*t8*abb93n21+t5*t7*abb93n34+t5*t8*abb93n10+t&
      &5*t9*abb93n11+t5*abb93n13*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k&
      &6(3)-Q(4)*spvak2k6(4))+t5*abb93n19*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3&
      &)*spvak2k4(3)-Q(4)*spvak2k4(4))+t6*t8*abb93n24+t7*t8*abb93n41+t1*t11*t5*a&
      &bb93n48+t1*t2*t3*abb93n28+t1*t2*t4*abb93n26+t1*t2*t6*abb93n26+t1*t2*t7*ab&
      &b93n45+t1*t2*t8*abb93n27+t13*t2*t3*abb93n43+t13*t2*t4*abb93n42+t13*t2*t6*&
      &abb93n44+t2*t3*t7*abb93n36+t2*t7*t8*abb93n35+t2*t7*t9*abb93n38)

      numerator = cmplx(real(d93, ki), aimag(d93), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d93h1l1
