module     p7_dubar_emnebargg_d13h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d13h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d13
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd13h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb13n14+abb13n26*dotproduct(k3, qshift)+abb13n26*dotprodu&
         &ct(k4, qshift)+abb13n27*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-s&
         &pvak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+abb13n28*(spvak5k2(1)*qshi&
         &ft(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-spvak5k2(4)*qshift(4&
         &))+abb13n29*(spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*q&
         &shift(3)-spvak2k5(4)*qshift(4))+abb13n30*dotproduct(k2, qshift)+abb13n&
         &31*dotproduct(k5, qshift)+abb13n32*(spvak3k4(1)*qshift(1)-spvak3k4(2)*&
         &qshift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb13n33*dotpro&
         &duct(k6, qshift)+abb13n34*dotproduct(k1, qshift)+abb13n35*(spvak6k5(1)&
         &*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-spvak6k5(4)*qsh&
         &ift(4))+abb13n36*(spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1&
         &(3)*qshift(3)-spvak6k1(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb13n17+k2(iv1)*abb13n21+k3(iv1)*abb13n25+k4(iv1)&
         &*abb13n25+k5(iv1)*abb13n20+k6(iv1)*abb13n18+spvak2k5(iv1)*abb13n22+spv&
         &ak3k1(iv1)*abb13n24+spvak3k4(iv1)*abb13n19+spvak5k2(iv1)*abb13n23+spva&
         &k6k1(iv1)*abb13n15+spvak6k5(iv1)*abb13n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d13:
   subroutine     reconstruct_d13(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_13:
      coeffs%coeffs_13%c0 = derivative(czip)
      coeffs%coeffs_13%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_13%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_13%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_13%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_13:
   end subroutine reconstruct_d13
!---#] subroutine reconstruct_d13:
end module p7_dubar_emnebargg_d13h3l1d
