module     p7_dubar_emnebargg_d49h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d49h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d49
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd49h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb49n21
         return
      end if
      t1 = k1(iv1)
      t2 = k3(iv1)
      t3 = k4(iv1)
      t4 = spvak3k1(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb49n31+k5(iv1)*abb49n38+k6(iv1)*abb49n32+t1*abb4&
         &9n34+t2*abb49n33+t3*abb49n33+t4*abb49n36+t5*abb49n35+t6*abb49n37)
         return
      end if
      t7 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb49n30+k1(iv2)*t6*abb49n25+k3(iv2)*t&
         &6*abb49n24+k4(iv2)*t6*abb49n24+spvak2k1(iv1)*t7*abb49n29+spvak2k1(iv2)&
         &*t6*abb49n29+spvak2k4(iv1)*t7*abb49n27+spvak2k4(iv2)*t6*abb49n27+spvak&
         &3k1(iv2)*t6*abb49n22+spvak3k4(iv2)*t6*abb49n23+spvak6k1(iv1)*t7*abb49n&
         &28+spvak6k1(iv2)*t6*abb49n28+spvak6k4(iv1)*t7*abb49n26+spvak6k4(iv2)*t&
         &6*abb49n26+t1*t7*abb49n25+t2*t7*abb49n24+t3*t7*abb49n24+t4*t7*abb49n22&
         &+t5*t7*abb49n23)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d49:
   subroutine     reconstruct_d49(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_49:
      coeffs%coeffs_49%c0 = derivative(czip)
      coeffs%coeffs_49%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_49%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_49%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_49%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_49%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_49%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_49%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_49%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_49%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_49%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_49%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_49%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_49%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_49%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_49:
   end subroutine reconstruct_d49
!---#] subroutine reconstruct_d49:
end module p7_dubar_emnebargg_d49h3l1d
